#!/usr/bin/perl
use strict;
use warnings;

use Parse::RecDescent;

my $grammar = <<"EOG";

C_Source:    Chunk(s) /\\Z/

Chunk:       Colored | Plain

Colored:     Blue | Red

# Typennamen
Blue:        / void     | int      | float | double
             | char     | short    | long  | signed
             | unsigned | enum     | const | static
             | struct/x

# Geschweifte Klammer
Red:         '{' | '}'

Plain:       /\\w+|./
                     
EOG

my $parser = Parse::RecDescent->new($grammar);

undef $/;
my $input = <STDIN>;
$parser->C_Source($input);


